

Enemy = {}
activeEnemies = {}

Enemy.__index = Enemy

function Enemy:new()
	local enemyObj = {}
	enemyObj.img = love.graphics.newImage("textures/red.png")
	enemyObj.width = enemyObj.img:getWidth()
	enemyObj.height = enemyObj.img:getHeight()
	enemyObj.x = math.random(0,love.window.getWidth()-enemyObj.width)
	enemyObj.y = math.random(0,love.window.getHeight()-enemyObj.height)
	enemyObj.age = 0

	return setmetatable(enemyObj, Enemy)
end

function Enemy:update(dt)
	self:collide()
	self.age = self.age + dt
end

function Enemy:collide()
	if self.age > 2 then
		if self.x + self.width > c.x and self.x < c.x + c.width and self.y + self.height > c.y and self.y < c.y + c.height then
			playerIsAlive = false
		end
	end
end

function Enemy:draw()
	if self.age < 2 then
		love.graphics.setColor(255,255,255,100)
		love.graphics.draw(self.img,self.x, self.y)
	else
		love.graphics.setColor(255,255,255,255)
		love.graphics.draw(self.img,self.x, self.y)
	end

	love.graphics.setColor(255,255,255,255)
end


function LOAD_ENEMIES()
	cycleTimer = 0
	cycleLength = 5
	cycleDelay = 2
end


function UPDATE_ENEMIES(dt)
	for i, enemy in ipairs(activeEnemies) do
		enemy:update(dt)
	end
end


function DRAW_ENEMIES()
    for i, enemy in ipairs(activeEnemies) do
        enemy:draw()
    end
end

function ENEMY_CYCLE(dt)
	cycleTimer = cycleTimer + dt
	if cycleTimer >= cycleLength + cycleDelay then
		ENEMY_SPAWN()
		cycleTimer = 0
	elseif cycleTimer >= cycleLength and cycleTimer < cycleLength + cycleDelay then
		ENEMY_DIE()
	end
end

function ENEMY_SPAWN()

	local lowerSpawnLimit = 50
	local upperSpawnLimit = 80
	local enemySpawnAmount = math.random(lowerSpawnLimit,upperSpawnLimit)
	for i=1,enemySpawnAmount do
		table.insert(activeEnemies, Enemy:new())
	end

end

function ENEMY_DIE()
	for i, enemy in ipairs(activeEnemies) do
    	table.remove(activeEnemies, i)
	end
end